<template>
	<view class="u-wrap">
		<view class="u-search-box">
			<view class="u-search-inner">
				<u-icon name="search" color="#909399" :size="28"></u-icon>
				<text class="u-search-text">搜索</text>
			</view>
		</view>
		<view class="u-menu-wrap">
			<scroll-view scroll-y scroll-with-animation class="u-tab-view menu-scroll-view" :scroll-top="scrollTop"
				:scroll-into-view="itemId">
				<view v-for="(item,index) in groupList" :key="index" class="u-tab-item"
					:class="[current == index ? 'u-tab-item-active' : '']" @tap.stop="swichMenu(index)">
					<text class="u-line-1">{{item.groupName}}</text>
				</view>
			</scroll-view>
			<scroll-view :scroll-top="scrollRightTop" scroll-y scroll-with-animation class="right-box"
				@scroll="rightScroll">

				<u-form :model="form" ref="uForm">
					<template v-for="(groupItem,groupIndex) in groupList">
						<view class="class-item" :key="groupIndex">
							<view class="title">{{groupItem.groupName}}</view>
							<view class="class-bd">
								<u-form-item v-for="(item,itemIndex) in groupItem.item" :key="itemIndex"
									:prop="item.fieldsName">
									<view class="label" @click="nextStep(item)">
										<text class="required" v-if="item.required">*</text>
										{{item.fieldsTitle}}
									</view>
									<template v-if="item.fieldsType">
										<xh-input v-if="item.fieldsType==='input'" :groupIndex="groupIndex"
											:itemIndex="itemIndex" :item="item" @value-change="fieldValueChange">
										</xh-input>
										<xh-radio v-if="item.fieldsType==='radio'" :groupIndex="groupIndex"
											:itemIndex="itemIndex" :item="item" @value-change="fieldValueChange">
										</xh-radio>
										<xh-checkbox v-if="item.fieldsType==='checkbox'" :groupIndex="groupIndex"
											:itemIndex="itemIndex" :item="item" @value-change="fieldValueChange">
										</xh-checkbox>
									</template>
								</u-form-item>
							</view>
						</view>
					</template>
				</u-form>
			</scroll-view>
		</view>
		<view @click="nextStep">下一步</view>
	</view>
</template>
<script>
	import classifyData from '@/common/classify.data.js';
	import XhInput from '@/components/createCom/XhInput.vue'
	import XhRadio from '@/components/createCom/XhRadio.vue'
	import XhCheckbox from '@/components/createCom/XhCheckbox.vue'
	// import XhRadio from '@/components/createCom/XhRadio.vue'
	export default {
		data() {
			return {
				scrollTop: 0, //tab标题的滚动条位置
				oldScrollTop: 0,
				current: 0, // 预设当前项的值
				menuHeight: 0, // 左边菜单的高度
				menuItemHeight: 0, // 左边菜单item的高度
				itemId: '', // 栏目右边scroll-view用于滚动的id
				groupList: classifyData, // 基本信息、安装 、勘察（其中一项表单数据）
				menuItemPos: [],
				arr: [],
				scrollRightTop: 0, // 右边栏目scroll-view的滚动条高度
				timer: null, // 定时器
				form: { // 一维表单
					name: 'name',
					radio: ''
				},
				rules: {
					name: [{
						required: true,
						min: 10,
						message: '姓名不能为空',
						// 可以单个或者同时写两个触发验证方式 
						trigger: ['change', 'blur'],
					}],
					mobile: [{
						required: true,
						min: 10,
						message: '姓名不能为空',
						// 可以单个或者同时写两个触发验证方式 
						trigger: ['change', 'blur'],
					}, {
						// 自定义验证函数，见上说明
						validator: (rule, value, callback) => {
							// 上面有说，返回true表示校验通过，返回false表示不通过
							// this.$u.test.mobile()就是返回true或者false的
							return this.$u.test.mobile(value);
						},
						message: '手机号码不正确',
						// 触发器可以同时用blur和change
						trigger: ['change', 'blur'],
					}]
				}
			}
		},
		components: {
			XhInput,
			XhRadio,
			XhCheckbox
			// formCom
		},
		created() {
			// console.log(allComponents,'allComponents')
		},
		onLoad() {

		},
		onReady() {
			this.$refs.uForm.setRules(this.rules);
			// 导航栏滚动切换
			this.getMenuItemTop()
		},
		updated() {
			console.log(this.form.name, 'form.name')
		},
		methods: {
			// 字段的值更新
			fieldValueChange(data) {
				// data.groupIndex data.itemIndex值下标 data.value //值
				console.log(data, 'data')
				const groupItem = this.groupList[data.groupIndex]
				let innerItem
				if (groupItem.item) {
					innerItem = groupItem.item[data.itemIndex]
				}
				console.log(innerItem, 'innerItem')
				this.form[innerItem.fieldsName] = data.value
				console.log(this.form, 'this.form')
			},
			nextStep(item) {
				// 下一步
				console.log(item, 'item')
			},

			// ------------------------- 以下方法为展示滚动切换 -------------------------
			// 点击左边的栏目切换
			async swichMenu(index) {
				if (this.arr.length == 0) {
					await this.getMenuItemTop();
				}
				if (index == this.current) return;
				this.scrollRightTop = this.oldScrollTop;
				this.$nextTick(function() {
					this.scrollRightTop = this.arr[index];
					this.current = index;
					this.leftMenuStatus(index);
				})
			},
			// 获取一个目标元素的高度
			getElRect(elClass, dataVal) {
				new Promise((resolve, reject) => {
					const query = uni.createSelectorQuery().in(this);
					query.select('.' + elClass).fields({
						size: true
					}, res => {
						// 如果节点尚未生成，res值为null，循环调用执行
						if (!res) {
							setTimeout(() => {
								this.getElRect(elClass);
							}, 10);
							return;
						}
						this[dataVal] = res.height;
						resolve();
					}).exec();
				})
			},
			// 观测元素相交状态
			async observer() {
				this.tabbar.map((val, index) => {
					let observer = uni.createIntersectionObserver(this);
					// 检测右边scroll-view的id为itemxx的元素与right-box的相交状态
					// 如果跟.right-box底部相交，就动态设置左边栏目的活动状态
					observer.relativeTo('.right-box', {
						top: 0
					}).observe('#item' + index, res => {
						if (res.intersectionRatio > 0) {
							let id = res.id.substring(4);
							this.leftMenuStatus(id);
						}
					})
				})
			},
			// 设置左边菜单的滚动状态
			async leftMenuStatus(index) {
				this.current = index;
				// 如果为0，意味着尚未初始化
				if (this.menuHeight == 0 || this.menuItemHeight == 0) {
					await this.getElRect('menu-scroll-view', 'menuHeight');
					await this.getElRect('u-tab-item', 'menuItemHeight');
				}
				// 将菜单活动item垂直居中
				this.scrollTop = index * this.menuItemHeight + this.menuItemHeight / 2 - this.menuHeight / 2;
			},
			// 获取右边菜单每个item到顶部的距离
			getMenuItemTop() {
				new Promise(resolve => {
					let selectorQuery = uni.createSelectorQuery();
					selectorQuery.selectAll('.class-item').boundingClientRect((rects) => {
						// 如果节点尚未生成，rects值为[](因为用selectAll，所以返回的是数组)，循环调用执行
						if (!rects.length) {
							setTimeout(() => {
								this.getMenuItemTop();
							}, 10);
							return;
						}
						rects.forEach((rect) => {
							// 这里减去rects[0].top，是因为第一项顶部可能不是贴到导航栏(比如有个搜索框的情况)
							this.arr.push(rect.top - rects[0].top);
							resolve();
						})
					}).exec()
				})
			},

			// 右边菜单滚动
			async rightScroll(e) {
				this.oldScrollTop = e.detail.scrollTop;
				if (this.arr.length == 0) {
					await this.getMenuItemTop();
				}
				if (this.timer) return;
				if (!this.menuHeight) {
					await this.getElRect('menu-scroll-view', 'menuHeight');
				}
				this.timer = setTimeout(() => { // 节流
					this.timer = null;
					// scrollHeight为右边菜单垂直中点位置
					let scrollHeight = e.detail.scrollTop + this.menuHeight / 2;
					for (let i = 0; i < this.arr.length; i++) {
						let height1 = this.arr[i];
						let height2 = this.arr[i + 1];
						// 如果不存在height2，意味着数据循环已经到了最后一个，设置左边菜单为最后一项即可
						if (!height2 || scrollHeight >= height1 && scrollHeight < height2) {
							this.leftMenuStatus(i);
							return;
						}
					}
				}, 10)
			}
		}
	}
</script>

<style lang="scss" scoped>
	// ----------------------------  表单样式begin  ----------------------------
	/deep/ .u-form-item {
		.u-form-item__message {
			padding-left: 0 !important;
		}

		.u-form-item--left__content--required {
			vertical-align: top;
		}
	}

	.class-item {
		.label {
			color: #333;
			font-size: 28rpx;
			line-height: 40rpx;
		}

		.required {
			padding-right: 10rpx;
			font-size: 28rpx;
			line-height: 40rpx;
			color: #fa3534;
		}
	}

	// ----------------------------  表单样式end  ----------------------------


	.u-wrap {
		height: calc(100vh);
		/* #ifdef H5 */
		height: calc(100vh - var(--window-top));
		/* #endif */
		display: flex;
		flex-direction: column;
	}

	.u-search-box {
		padding: 18rpx 30rpx;
	}

	.u-menu-wrap {
		flex: 1;
		display: flex;
		overflow: hidden;
	}

	.u-search-inner {
		background-color: rgb(234, 234, 234);
		border-radius: 100rpx;
		display: flex;
		align-items: center;
		padding: 10rpx 16rpx;
	}

	.u-search-text {
		font-size: 26rpx;
		color: $u-tips-color;
		margin-left: 10rpx;
	}

	.u-tab-view {
		width: 200rpx;
		height: 100%;
	}

	.u-tab-item {
		height: 110rpx;
		background: #f6f6f6;
		box-sizing: border-box;
		display: flex;
		align-items: center;
		justify-content: center;
		font-size: 26rpx;
		color: #444;
		font-weight: 400;
		line-height: 1;
	}

	.u-tab-item-active {
		position: relative;
		color: #000;
		font-size: 30rpx;
		font-weight: 600;
		background: #fff;
	}

	.u-tab-item-active::before {
		content: "";
		position: absolute;
		border-left: 4px solid $u-type-primary;
		height: 32rpx;
		left: 0;
		top: 39rpx;
	}

	.u-tab-view {
		height: 100%;
	}

	.right-box {
		background-color: rgb(250, 250, 250);
	}

	.page-view {
		padding: 16rpx;
	}

	.class-item {
		margin-bottom: 30rpx;
		background-color: #fff;
		padding: 16rpx;
		border-radius: 8rpx;
	}

	.class-item:last-child {
		min-height: 100vh;
	}

	.item-title {
		font-size: 26rpx;
		color: $u-main-color;
		font-weight: bold;
	}

	.item-menu-name {
		font-weight: normal;
		font-size: 24rpx;
		color: $u-main-color;
	}

	.item-container {
		display: flex;
		flex-wrap: wrap;
	}

	.thumb-box {
		width: 33.333333%;
		display: flex;
		align-items: center;
		justify-content: center;
		flex-direction: column;
		margin-top: 20rpx;
	}

	.item-menu-image {
		width: 120rpx;
		height: 120rpx;
	}
</style>
